]> git.pld-linux.org Git - packages/mysql.git/blame - mysql.init
- more mysqld.conf changes: skip-locking, default-character-set
[packages/mysql.git] / mysql.init
CommitLineData
53a28f77 1#!/bin/sh
2#
7429b124 3# mysql A very fast and reliable SQL database engine
53a28f77 4#
7429b124 5# chkconfig: 2345 84 25
53a28f77 6#
350d9d8c 7# description: A very fast and reliable SQL database engine.
53a28f77 8#
0b079830
ER
9# $Id$
10
53a28f77 11# Source function library
12. /etc/rc.d/init.d/functions
13
14# Get network config
15. /etc/sysconfig/network
16
aac2c31f
AM
17# Get service config
18if [ -f /etc/sysconfig/mysql ]; then
350d9d8c 19 . /etc/sysconfig/mysql
aac2c31f 20else
350d9d8c 21 nls "Error: %s not found" /etc/sysconfig/mysql
95b0575d 22 nls "%s can't be run." MySQL
350d9d8c
PG
23 exit 1
24fi
25
0146fae1 26if [ -n "$MYSQL_DB_CLUSTERS" ]; then
350d9d8c 27 nls "Warning: MYSQL_DB_CLUSTERS is set. It's obsolete. Use %s instead." /etc/mysql/clusters.conf
aac2c31f
AM
28fi
29
95b0575d 30if [ -f /etc/mysql/clusters.conf ]; then
ca39347b 31 MYSQL_DB_CLUSTERS=$(awk -F= '!/^#/ && /=/{print $2}' /etc/mysql/clusters.conf)
95b0575d
ER
32 if [ -z "$MYSQL_DB_CLUSTERS" ]; then
33 nls "Warning: there are no configured clusters."
34 fi
0146fae1 35
95b0575d 36else
0146fae1 37 nls "Warning: Missing clusters config file %s" /etc/mysql/clusters.conf
95b0575d
ER
38 if [ -z "$MYSQL_DB_CLUSTERS" ]; then
39 nls "Warning: there are no configured clusters."
40 nls "Using default cluster /var/lib/mysql (compatibility mode)"
41 MYSQL_DB_CLUSTERS=/var/lib/mysql
42 fi
aac2c31f
AM
43fi
44
95b0575d 45
ac28c610 46# Check that networking is up
8eb71226 47if is_yes "${NETWORKING}"; then
213fc2f2 48 if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status -a "$1" != init ]; then
8eb71226 49 msg_network_down MySQL
50 exit 1
51 fi
52else
53 exit 0
e9ca44ab 54fi
55
aac2c31f
AM
56action="$1"
57
58# any db cluster as command line argument?
521444a9 59if [ $# -gt 1 ]; then
350d9d8c
PG
60 shift
61 # perform action for specified clusters only
30b2aa9a
ER
62 for a in "$@"; do
63 # try auto resolving from /etc/mysql/clusters.conf
64 if [[ "$a" != /* ]]; then
65 m=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $1}' /etc/mysql/clusters.conf)
66 if [ -z "$m" ]; then
67 echo >&2 "Cluster name '$a' did not match anything!"
68 exit 1
69 fi
70 if [ $(echo "$m" | wc -l) -gt 1 ]; then
71 echo >&2 "Cluster name '$a' ambiguous:" $m
72 exit 1
73 fi
74 a=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $2}' /etc/mysql/clusters.conf)
75 fi
76 DB_CLUSTERS="$DB_CLUSTERS $a"
77 done
aac2c31f 78else
350d9d8c 79 DB_CLUSTERS="$MYSQL_DB_CLUSTERS"
53a28f77 80fi
81
7c1478d5
ER
82# global error log, if mysqld.conf hasn't migrated to log-error style
83MYSQL_ERRLOG=/var/log/mysql/mysqld.log
c85758f0 84MYSQL_STOP_WAIT_TIME=${MYSQL_STOP_WAIT_TIME:-900}
aac2c31f
AM
85
86#
87# Useful functions.
88#
89
90#
91# check for mysql status
92#
93# arguments:
94# $1 - db cluster
c85758f0 95# $2 - start|stop
aac2c31f
AM
96#
97# sets variables:
c85758f0 98# MYSQL_STATUS = starting | running | not running | died
aac2c31f
AM
99# MYSQL_PID = pid of mysqld process
100#
101mysqlstatus() {
102 clusterdir="$1"
c85758f0
AM
103 mode="$2"
104
aac2c31f 105 mysqlgetconfig "$clusterdir"
d405c4eb 106
350d9d8c
PG
107 MYSQL_STATUS="not running"
108 MYSQL_PID="unknown"
c85758f0
AM
109 MYSQL_PIDFILE_PID=""
110 MYSQL_GREP_PID=""
aac2c31f 111
c85758f0
AM
112 if [ -f "$MYSQL_PIDFILE" ]; then
113 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
114 fi
115
116 if [ -n "$MYSQL_PIDFILE_PID" ]; then
117 MYSQL_PID=$MYSQL_PIDFILE_PID
118 if [ ! -d "/proc/$MYSQL_PID" ]; then
119 MYSQL_STATUS="died"
120 return
376ffa12 121 elif (grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null); then
c85758f0
AM
122 MYSQL_STATUS="running"
123 return
124 fi
125 fi
6d3c5db5 126
c85758f0 127 if [ "$mode" = "start" ]; then
376ffa12 128 MYSQL_GREP_PID=$(grep -lE "^/usr/sbin/mysqld.*${MYSQL_PIDFILE}" /proc/[0-9]*/cmdline 2> /dev/null | awk -F "/" '{ print $3; exit; }')
c85758f0
AM
129 if [ -n "$MYSQL_GREP_PID" ]; then
130 MYSQL_PID=$MYSQL_GREP_PID
0ca65658 131 if grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null; then
c85758f0
AM
132 if [ -f "$MYSQL_PIDFILE" ]; then
133 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
134 fi
135 if [ -n "$MYSQL_PIDFILE_PID" ]; then
136 MYSQL_PID=$MYSQL_PIDFILE_PID
137 MYSQL_STATUS="running"
138 return
139 else
140 MYSQL_STATUS="starting"
141 return
142 fi
143 fi
144 fi
6d3c5db5 145 fi
c85758f0
AM
146
147 # else default, "not running"
aac2c31f
AM
148}
149
150# get mysql configuration in variables
5e3157a9 151# MYSQL_CONFIG MYSQL_CLUSTER_DIR
e6d4b62c 152# MYSQL_DATA_DIR MYSQL_USER MYSQL_PIDFILE MYSQL_SOCKET MYSQL_PORT MYSQL_BIND_ADDRESS MYSQL_SKIP_NETWORKING MYSQL_LOG_ERROR
aac2c31f
AM
153#
154# arguments
155# $1 - db cluster
156
157mysqlgetconfig() {
5e3157a9 158 local clusterdir="$1" config_file
aac2c31f
AM
159
160 # emulate old behaviour if only one cluster specified
161 if [ "$clusterdir" = "$MYSQL_DB_CLUSTERS" -a "$clusterdir" = "/var/lib/mysql" -a -f /etc/mysqld.conf ]; then
0ca65658 162 MYSQL_RA_COMPAT=yes
aac2c31f 163 config_file=/etc/mysqld.conf
521444a9 164 else
5e3157a9 165 local config=$(awk -F= -vclusterdir="$clusterdir" '!/^#/{ if (clusterdir == $2) print $1}' /etc/mysql/clusters.conf)
0ca65658 166 if [[ $config = /* ]]; then
d54e166d 167 config_file="$config"
fe2f6e01 168 elif [ -f "/etc/mysql/$config" ]; then
0ca65658 169 config_file="/etc/mysql/$config"
d54e166d
AM
170 else
171 config_file="$clusterdir/mysqld.conf"
172 fi
350d9d8c 173 fi
aac2c31f 174
0ca65658 175 MYSQL_CLUSTER_DIR="$clusterdir"
d405c4eb 176
521444a9 177 if [ -z "$config_file" ]; then
f9ad67df
PG
178 nls "Error: Can't find config file for %s cluster" "$clusterdir"
179 exit 6
180 else
0ca65658 181 MYSQL_CONFIG="$config_file"
f9ad67df 182 fi
d405c4eb 183
aac2c31f
AM
184 if [ ! -f "$config_file" ]; then
185 nls "Error: config file %s not found" "$config_file"
350d9d8c
PG
186 nls "MySQL can't be run. Did you initialize DB by doing \`$0 init'?"
187 exit 6
aac2c31f
AM
188 fi
189
b3be1198 190 # reset to initial state
e6d4b62c 191 MYSQL_DATA_DIR= MYSQL_USER= MYSQL_PIDFILE= MYSQL_SOCKET= MYSQL_PORT= MYSQL_BIND_ADDRESS= MYSQL_SKIP_NETWORKING= MYSQL_LOG_ERROR=
b3be1198
ER
192
193 eval `awk -F= '
ca39347b
ER
194 {
195 # undos
196 gsub(/\r$/, "");
197
198 # trim spaces
3dc69a76
ER
199 gsub(/^[\t ]+|[\t ]+$/, "", $1);
200 gsub(/^[\t ]+|[\t ]+$/, "", $2);
ca39347b
ER
201 }
202
b3be1198
ER
203 # skip comments and empty lines
204 /^[;#]|^ *$/ { next }
205
206 /^[ \t]*\[.*\][ \t]*$/ {
207 match($0, /\[.*\]/);
208 section = substr($0, RSTART + 1, RSTART + RLENGTH - 3);
209 next;
823c13f7 210 }
e9ca44ab 211
b3be1198 212 section == "mysqld" {
3dc69a76 213 if ($1 == "datadir") {
b3be1198 214 printf("MYSQL_DATA_DIR=%s;", $2);
3dc69a76 215 } else if ($1 == "user") {
b3be1198 216 printf("MYSQL_USER=%s;", $2);
3dc69a76 217 } else if ($1 == "pid-file") {
b3be1198 218 printf("MYSQL_PIDFILE=%s;", $2);
3dc69a76 219 } else if ($1 == "socket") {
b3be1198 220 printf("MYSQL_SOCKET=%s;", $2);
3dc69a76 221 } else if ($1 == "port") {
b3be1198 222 printf("MYSQL_PORT=%s;", $2);
3dc69a76 223 } else if ($1 == "bind-address") {
b3be1198 224 printf("MYSQL_BIND_ADDRESS=%s;", $2);
3dc69a76 225 } else if ($1 == "skip-networking") {
9e39a858 226 printf("MYSQL_SKIP_NETWORKING=1;");
3dc69a76 227 } else if ($1 == "log-error") {
e6d4b62c 228 printf("MYSQL_LOG_ERROR=%s;", $2);
b3be1198
ER
229 }
230 }
231 ' $config_file`
e9ca44ab 232
e6d4b62c
ER
233 # error log not defined in config file. add one
234 if [ -z "$MYSQL_LOG_ERROR" ]; then
235 MYSQL_LOG_ERROR=$MYSQL_ERRLOG
236 else
237 # unset, so mysqld would use value from config itself
238 unset MYSQL_LOG_ERROR
239 fi
240
d54e166d 241 if is_yes "$MYSQL_RA_COMPAT"; then
350d9d8c 242 MYSQL_DATA_DIR_SUB=""
8ee1d59c 243 else
350d9d8c 244 MYSQL_DATA_DIR_SUB="/mysqldb"
8ee1d59c 245 fi
d405c4eb 246
8ee1d59c 247 if [ -z "$MYSQL_DATA_DIR" -o "$MYSQL_DATA_DIR" != "${clusterdir}${MYSQL_DATA_DIR_SUB}/db" ]; then
350d9d8c
PG
248 nls "Error: datadir specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/db"
249 nls " MySQL can't be run."
250 exit 6
8ee1d59c 251 fi
d405c4eb 252
8ee1d59c
AM
253 if [ -z "$MYSQL_PIDFILE" -o "$MYSQL_PIDFILE" != "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid" ]; then
254 nls "Error: pid-file specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid"
255 nls " MySQL can't be run."
256 exit 6
257 fi
e9ca44ab 258
e6d4b62c 259 if [ -z "$MYSQL_USER" ]; then
350d9d8c
PG
260 echo "$(nls 'MySQL user not configured properly')"'!' >&2
261 nls "Edit %s and configure it." "$config_file" >&2
262 exit 6
860cd80c 263 fi
aac2c31f 264}
e9ca44ab 265
aac2c31f
AM
266# start mysql
267mysqlstart() {
5e3157a9 268 local clusterdir="$1"
aac2c31f
AM
269 mysqlgetconfig "$clusterdir"
270 if [ ! -d "$MYSQL_DATA_DIR/mysql" ]; then
271 nls "MySQL cluster %s not initialized." "$clusterdir"
272 nls "Try \`%s init %s' before start." "$0" "$clusterdir"
350d9d8c
PG
273 exit 6
274 fi
02e96f2e 275
5e3157a9 276 msg_starting "MySQL $clusterdir"; busy
aac2c31f 277 [ -z "$DEFAULT_SERVICE_RUN_NICE_LEVEL" ] && DEFAULT_SERVICE_RUN_NICE_LEVEL=0
c85758f0 278 rm -f "$MYSQL_PIDFILE"
c4fbabf1 279
7c1478d5 280
c4fbabf1 281 TMPDIR=/tmp nice -n ${SERVICE_RUN_NICE_LEVEL:-$DEFAULT_SERVICE_RUN_NICE_LEVEL} \
7429b124 282 /usr/bin/setsid /usr/sbin/mysqld \
c4fbabf1
ER
283 --defaults-file=$MYSQL_CONFIG \
284 --datadir=$MYSQL_DATA_DIR \
7c1478d5 285 --pid-file=$MYSQL_PIDFILE \
e6d4b62c 286 ${MYSQL_LOG_ERROR:+--log-error="$MYSQL_LOG_ERROR"} \
7c1478d5 287 $MYSQL_OPTIONS &
c4fbabf1
ER
288 pid=$!
289
290 sleep 0.1
c85758f0
AM
291 mysqlstatus "$clusterdir" start
292 # it takes longer for mysqld to start and create pidfile if it has to recover innodb transactions
293 if [ "$MYSQL_STATUS" = "starting" ]; then
c4fbabf1
ER
294 echo ""
295 show "Waiting for MySQL to start"
296 busy
297
298 # while the pid is running, mysql is starting up
299 # if the pidfile was created, it started up successfully
300 # if either case fails we break and report status
301 while true; do
302 [ -d /proc/$pid ] || break
c85758f0 303 [ -f "$MYSQL_PIDFILE" ] && break
c4fbabf1 304 sleep 0.2
c85758f0
AM
305 done
306 fi
307
308 mysqlstatus "$clusterdir" start
6d3c5db5 309 if [ "$MYSQL_STATUS" = "running" -a "$MYSQL_PID" != "unknown" ]; then
aac2c31f 310 ok
47fd5a6a 311 elif [ "$MYSQL_STATUS" = "died" ]; then
350d9d8c 312 RETVAL=1
47fd5a6a 313 died
aac2c31f
AM
314 else
315 RETVAL=1
316 fail
53a28f77 317 fi
aac2c31f
AM
318}
319
320# stop mysql
321mysqlstop() {
5e3157a9 322 local clusterdir="$1"
c85758f0 323 mysqlstatus "$clusterdir" stop
aac2c31f
AM
324 msg_stopping "MySQL $clusterdir"
325 busy
95b0575d 326
95b0575d 327 # try graceful shutdown -- send shutdown command
566e62bb 328 # requires mysql_sysadmin user proper privs
465c110e 329 /usr/bin/mysqladmin --defaults-file=$MYSQL_CONFIG ${MYSQL_SOCKET:+--socket=$MYSQL_SOCKET} shutdown >/dev/null 2>&1
c85758f0 330 mysqlstatus "$clusterdir" stop
95b0575d 331
c85758f0
AM
332 if [ "$MYSQL_PID" != "unknown" ]; then
333 kill -TERM "$MYSQL_PID" 2> /dev/null
334 for nr in $(seq 1 $(($MYSQL_STOP_WAIT_TIME*10))); do
335 [ -d "/proc/$MYSQL_PID" ] || break
336 sleep 0.1
337 done
338 fi
339
340 mysqlstatus "$clusterdir" stop
47fd5a6a 341 if [ "$MYSQL_STATUS" = "died" ]; then
350d9d8c 342 died
c85758f0 343 elif [ "$MYSQL_STATUS" = "running" -o "$MYSQL_STATUS" = "starting" ]; then
aac2c31f 344 fail
b92e5cd1 345 else
aac2c31f 346 ok
b92e5cd1 347 fi
aac2c31f
AM
348}
349
350#
351# check for running mysql instances; if any instance is running then
352# create subsys lock file
353#
354mysqlsubsys() {
350d9d8c
PG
355 # check for every defined db cluster in sysconfig file
356 for mysqldir in $DB_CLUSTERS; do
357 mysqlstatus "$mysqldir"
358 if [ "$MYSQL_STATUS" = "running" ]; then
359 touch /var/lock/subsys/mysql
360 return
361 fi
362 done
363 rm -f /var/lock/subsys/mysql
aac2c31f
AM
364}
365
366mysqlinit() {
5e3157a9 367 local clusterdir="$1"
8ee1d59c
AM
368
369 if [ -f /etc/mysqld.conf ]; then
350d9d8c
PG
370 nls "Running in \`no cluster compat' mode: can't initialize database."
371 nls "Move /etc/mysqld.conf away and rerun \`$0 init' (new config will be in $clusterdir)."
372 exit 1
8ee1d59c
AM
373 fi
374
521444a9
AM
375 if [ -f "$clusterdir/mysqld.conf" ]; then
376 mysqlgetconfig "$clusterdir"
377 else
378 MYSQL_USER="mysql"
379 MYSQL_CLUSTER_DIR="$clusterdir"
380 MYSQL_DATA_DIR="$clusterdir/mysqldb/db"
381 MYSQL_PIDFILE="$clusterdir/mysqldb/mysql.pid"
382 MYSQL_SOCKET="$clusterdir/mysqldb/mysql.sock"
fe98cc4a
ER
383
384 # this $MYSQL_CONFIG will be created later
385 MYSQL_CONFIG="$MYSQL_CLUSTER_DIR/mysqld.conf"
521444a9 386 fi
aac2c31f 387
092832b7 388 show "Initializing cluster %s" "$clusterdir"; started
aac2c31f 389
573e1dcc 390 # Check if not exist init database
e9ca44ab 391 if [ -d "$MYSQL_DATA_DIR/mysql" ]; then
c70c8930 392 nls "Seems that database is initialized now. Remove by hand %s" "$MYSQL_DATA_DIR/mysql"
b92e5cd1 393 nls "before initializing database."
aac2c31f
AM
394 nls "For now skipping cluster %s." "$clusterdir"
395 return
e9ca44ab 396 fi
397
5f961775 398 show "Installing MySQL system tables for $MYSQL_DATA_DIR"
e9ca44ab 399 busy
d405c4eb
JB
400 TMP=/tmp TMPDIR=/tmp
401
c4fbabf1 402 mkdir -p "$MYSQL_DATA_DIR" > /dev/null 2>&1
f5d63301
AM
403 # Using mysql:mysql for MYSQL_CLUSTER_DIR is creating SECURITY hole, root:root is proper
404 chown root:root "$MYSQL_CLUSTER_DIR"
5f961775 405 chown mysql:mysql "$MYSQL_CLUSTER_DIR/mysqldb" "$MYSQL_DATA_DIR" > /dev/null 2>&1
653cf157 406 chmod 751 "$MYSQL_CLUSTER_DIR" "$MYSQL_CLUSTER_DIR/mysqldb"
444f9f3c
AM
407
408 if [ -f /usr/share/mysql/mysqld.conf -a ! -f "$MYSQL_CLUSTER_DIR/mysqld.conf" ]; then
b6369c60
ER
409 sed -e "
410 s#\(datadir.*\)=.*#\1= $MYSQL_DATA_DIR#g;
411 s#\(pid-file.*\)=.*#\1= $MYSQL_PIDFILE#g;
412 s#\(socket.*\)=.*#\1= $MYSQL_SOCKET#g;
413 s#@clusterdir@#$MYSQL_CLUSTER_DIR#g;
414 " /usr/share/mysql/mysqld.conf > "$MYSQL_CLUSTER_DIR/mysqld.conf"
54a1f368 415 chown root:root "$MYSQL_CLUSTER_DIR/mysqld.conf"
444f9f3c
AM
416 chmod 640 "$MYSQL_CLUSTER_DIR/mysqld.conf"
417 fi
cc4d3f78 418
a08fc1eb 419 if [ ! -e /var/lib/mysql/mysql.sock ] || [ -L /var/lib/mysql/mysql.sock ] && [ -z "$(readlink /var/lib/mysql/mysql.sock)" ]; then
0ca65658 420 sock=${MYSQL_SOCKET#/var/lib/mysql/} # make it relative if possible
5fe13e55 421 ln -s "$sock" /var/lib/mysql/mysql.sock
cc4d3f78 422 fi
aac2c31f 423
b9c4f95d 424 cat > $MYSQL_DATA_DIR/mysql-init.sql <<-EOF
bb39d376 425 CREATE DATABASE mysql;
4444725f 426 use mysql;
ac02fcd5 427 $(cat /usr/share/mysql/mysql_system_tables.sql)
5f961775 428 $(sed -e "/@current_hostname/d" /usr/share/mysql/mysql_system_tables_data.sql)
b9c4f95d
ER
429EOF
430
431 ok=0
5ab9fb7b
JR
432 /usr/sbin/mysqld \
433 --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
434 --bootstrap \
435 --skip-grant-tables \
436 --datadir=$MYSQL_DATA_DIR \
437 --user=$MYSQL_USER \
438 --slave-load-tmpdir=$MYSQL_DATA_DIR \
439 --tmpdir=$MYSQL_DATA_DIR \
440 --log-error=$MYSQL_ERRLOG \
da87c30d 441 < $MYSQL_DATA_DIR/mysql-init.sql && ok=1
5062ac41 442 [ -f $MYSQL_DATA_DIR/mysql/host.frm ] || ok=0
c4fbabf1 443
b9c4f95d
ER
444 if [ "$ok" = 1 ]; then
445 rm -f $MYSQL_DATA_DIR/mysql-init.sql
5f961775
JR
446 ok
447 cat << END_OF_MSG
6a46c354 448
449PLEASE REMEMBER TO SET A PASSWORD FOR THE MySQL USERS!
5f961775
JR
450This is done, after starting database, in the order shown,
451with:
452
453For 'mysql_sysadmin' (RELOAD and SHUTDOWN privileges):
454echo "update mysql.user set password=password('newpassword') where user='mysql_sysadmin'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
6a46c354 455
5f961775
JR
456For 'mysql' user (ALL privileges, DB admin):
457echo "update mysql.user set password=password('newpassword') where user='mysql'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
6a46c354 458
566e62bb 459NOTE: mysql_sysadmin password should be placed to $MYSQL_CONFIG in
6a46c354 460mysqladmin section. See the manual for more instructions.
566e62bb 461(This user is used at logs rotation and server shutdown)
e9ca44ab 462
5f961775
JR
463END_OF_MSG
464 show "Filling help tables..."
465 ok=0
466 ( echo "use mysql;"; cat /usr/share/mysql/fill_help_tables.sql ) | \
9b5b7a74
ER
467 /usr/sbin/mysqld \
468 --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
469 --bootstrap \
470 --skip-grant-tables \
9b5b7a74
ER
471 --datadir=$MYSQL_DATA_DIR \
472 --user=$MYSQL_USER \
473 --slave-load-tmpdir=$MYSQL_DATA_DIR \
474 --tmpdir=$MYSQL_DATA_DIR \
475 --log-error=$MYSQL_ERRLOG \
da87c30d 476 && ok=1
5f961775
JR
477 if [ "$ok" = 1 ]; then
478 ok
479 else
480 cat << END_OF_MSG
481
482WARNING: HELP FILES ARE NOT COMPLETELY INSTALLED!
483The "HELP" command might not work properly.
16bf26ff 484
e9ca44ab 485END_OF_MSG
5f961775
JR
486 fi
487 else
488 fail
489 cat << END_OF_MSG
e9ca44ab 490Installation of grant tables FAILED!
491
6df74636
ER
492The initialization SQL script was preserved at $MYSQL_DATA_DIR/mysql-init.sql
493
b9c4f95d
ER
494Examine the logs in /var/log/mysql for more information. You can
495also try to start the mysqld daemon with:
e9ca44ab 496
497/usr/sbin/mysqld --skip-grant &
498
dc7a177f 499You can use the command line tool mysql to connect to the mysql
e9ca44ab 500database and look at the grant tables:
501
dc7a177f 502shell> mysql -u mysql mysql
e9ca44ab 503mysql> show tables
504
505Try 'mysqld --help' if you have problems with paths. Setting on
4581ca2d 506logging in $MYSQL_DATA_DIR/mysqld.conf gives you a log in /var/log/mysql/query.log that
e9ca44ab 507may be helpful. The latest information about MySQL is available on the
78b16243 508web at http://www.mysql.com/.
e9ca44ab 509
a3eb9e7b 510Please check PLD Linux ftp site for newer versions of this package.
e9ca44ab 511
512Please consult the MySQL manual section: 'Problems running
513mysql_install_db', and the manual section that describes problems on
514your OS. Another information source is the MySQL email archive.
e9ca44ab 515
516END_OF_MSG
5f961775 517 exit 1
aac2c31f
AM
518 fi
519}
520
521#
522# End of useful functions.
523#
524
323256af 525start() {
5e3157a9 526 local mysqldir
aac2c31f 527 for mysqldir in $DB_CLUSTERS; do
c85758f0 528 mysqlstatus "$mysqldir" start
aac2c31f
AM
529 if [ "$MYSQL_STATUS" = "running" ]; then
530 msg_already_running "MySQL $mysqldir"
531 else
532 mysqlstart "$mysqldir"
533 fi
534 done
535 mysqlsubsys
323256af
ER
536}
537
538stop() {
5e3157a9 539 local mysqldir
aac2c31f 540 for mysqldir in $DB_CLUSTERS; do
c85758f0 541 mysqlstatus "$mysqldir" stop
aac2c31f
AM
542 if [ "$MYSQL_STATUS" = "not running" ]; then
543 msg_not_running "MySQL $mysqldir"
544 else
545 mysqlstop "$mysqldir"
546 fi
547 done
548 mysqlsubsys
323256af
ER
549}
550
7429b124 551condrestart() {
5e3157a9 552 if [ ! -f /var/lock/subsys/mysql ]; then
7429b124
JB
553 msg_not_running "MySQL"
554 RETVAL=$1
5e3157a9 555 return
7429b124 556 fi
5e3157a9
ER
557
558 stop
559 start
7429b124
JB
560}
561
323256af
ER
562RETVAL=0
563case "$action" in
564 start)
33cdd78d 565 start
323256af
ER
566 ;;
567 stop)
33cdd78d 568 stop
aac2c31f 569 ;;
7429b124
JB
570 restart)
571 stop
572 start
573 ;;
574 try-restart)
575 condrestart 0
576 ;;
577 force-reload)
578 condrestart 7
579 ;;
33cdd78d
ER
580 init)
581 for mysqldir in $DB_CLUSTERS; do
582 mysqlinit "$mysqldir"
583 done
584 exit $?
585 ;;
586 flush-logs)
587 for mysqldir in $DB_CLUSTERS; do
588 mysqlgetconfig "$mysqldir"
589 # just if mysqld is really running
590 if /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" ping >/dev/null 2>&1; then
591 /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" flush-logs
592 fi
593 done
594 ;;
aac2c31f
AM
595 status)
596 for mysqldir in $DB_CLUSTERS; do
597 mysqlstatus "$mysqldir"
2bac5c2d 598 if [ "$MYSQL_STATUS" = "running" ]; then
b3be1198
ER
599 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
600 port=${MYSQL_PORT:-3306}
601 socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
602 pid=$MYSQL_PID
9e39a858
ER
603 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
604 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
605 nls "\tunix:%s\n" "$socket"
b2bb6a82 606 pids="$pids/$MYSQL_PID/"
2bac5c2d
ER
607 progress "$MYSQL_STATUS"
608 else
27698ac1 609 show "MySQL cluster %s" "$mysqldir"
2bac5c2d
ER
610 progress "$MYSQL_STATUS" "$CFAIL"
611 fi
612 echo
aac2c31f 613 done
b2bb6a82
ER
614
615 for pid in $(/sbin/pidof mysqld); do
616 if [[ $pids != */$pid/* ]]; then
617 running="$running $pid"
618 fi
619 done
b7d0a657 620
a5595931 621 if [ $# = 1 -a "$running" ]; then
b2bb6a82
ER
622 nls "Warning: MySQL Daemon processes not under clusters.conf control:"
623 # see if we can display their status
624 for pid in $running; do
b7d0a657 625 datadir=$(cat /proc/$pid/cmdline | tr '\0' '\n' | fgrep -- --datadir=)
b2bb6a82
ER
626 datadir=${datadir#--datadir=} # strip --datadir
627 mysqldir=${datadir%/mysqldb/db} # strip /mysqldb/db
628 mysqlstatus "$mysqldir"
629 if [ "$MYSQL_STATUS" = "running" ]; then
b3be1198
ER
630 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
631 port=${MYSQL_PORT:-3306}
632 socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
9e39a858
ER
633 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
634 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
635 nls "\tunix:%s\n" "$socket"
b2bb6a82
ER
636 progress "$MYSQL_STATUS"
637 else
638 show "MySQL cluster %s" "$mysqldir"
639 progress "$MYSQL_STATUS" "$CFAIL"
640 fi
641 echo
642 done
643 fi
aac2c31f 644 ;;
53a28f77 645 *)
33cdd78d 646 msg_usage "$0 {start|stop|restart|try-restart|force-reload|init|flush-logs|status}"
02e96f2e 647 exit 3
53a28f77 648esac
40c36bca 649
ee9b6a50 650exit $RETVAL
This page took 0.156327 seconds and 4 git commands to generate.